
import java.io.IOException;

import javax.jms.*;
import javax.naming.NamingException;

//import org.hornetq.api.core.BroadcastEndpointFactoryConfiguration;
import org.hornetq.api.core.DiscoveryGroupConfiguration;
import org.hornetq.api.jms.HornetQJMSClient;
import org.hornetq.api.jms.JMSFactoryType;
import org.hornetq.jms.client.HornetQConnectionFactory;




public class MessageProducerWithSession 
{
	javax.naming.Context ic = null;
	javax.jms.QueueConnectionFactory cf = null;
	javax.jms.QueueConnection connection =  null;
	javax.jms.Queue queue = null;
	javax.jms.QueueSession session = null;
	
	String destinationName = "queue/ResponseQueue";

	public static void main(final String[] args) throws IOException, InterruptedException
	{
		MessageProducerWithSession qproducer= new MessageProducerWithSession();
		try 
		{
			qproducer.getInitialContext();
			qproducer.connectAndCreateSession();
			qproducer.produce();
			qproducer.closeConnection();
		}
		catch (NamingException e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		catch (JMSException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}


	}

	void getInitialContext() throws NamingException
	{

		java.util.Properties p = new java.util.Properties();		

		p.put(javax.naming.Context.INITIAL_CONTEXT_FACTORY,"org.jnp.interfaces.NamingContextFactory");
		p.put(javax.naming.Context.URL_PKG_PREFIXES,"org.jboss.naming:org.jnp.interfaces");			
		p.put(javax.naming.Context.PROVIDER_URL, "jnp://192.168.75.211:1099");

		ic = new javax.naming.InitialContext(p);


	} 
	void connectAndCreateSession() throws NamingException, JMSException 
	{
		queue = (Queue)ic.lookup(destinationName);
		
					
		cf = (javax.jms.QueueConnectionFactory)ic.lookup("/ConnectionFactory");
	
		queue = (Queue)ic.lookup(destinationName);
		connection = cf.createQueueConnection();

		session = connection.createQueueSession(true, 0);

		connection.start();				
	}
	public  void closeConnection()
	{
		if (session != null ) 
		{
			try
			{
				session.close();
			} catch (JMSException e) 
			{
				e.printStackTrace();
			}
		}

		if (connection != null) 
		{
			try 
			{
				connection.close();
			} catch (JMSException e)
			{		
				e.printStackTrace();
			}				
		}

	}

	public void produce() throws IOException, InterruptedException
	{
		try 
		{
			MessageProducer qproducer = session.createProducer(queue);
			int i = 0;
			for( i=0;i<10;i++)
			{
				System.out.println("Enter to proceed");
				System.in.read();
				
				
				TextMessage message = session.createTextMessage("This is a text message....." + i);

				System.out.println("Sent message---> " + message.getText());

				qproducer.send(message);
				
				
				// session.commit();
               
			}
			
			 
				for( i=0;i<10;i++)
				{
					System.out.println("Enter to proceed");
				//	System.in.read();
					
					
					TextMessage message = session.createTextMessage("This is a text message....." + i);

					System.out.println("Sent message---> " + message.getText());

					qproducer.send(message);
					
					Thread.sleep(1000);
					// session.commit();
	               
				}
				session.commit();

		} 
		catch(TransactionRolledBackException e)
		{
			System.err.println("****transaction Rolled Back Exception occured***");
			e.getMessage();
			e.printStackTrace();
			e.getClass();
		}
		catch (JMSException e)
		{
			System.err.println("****JMSException  occured***");

			e.getMessage();
			e.printStackTrace();
			e.getClass();
		}
		catch (Exception e)
		{
			System.err.println("****Exception  occured***");

			e.getMessage();
			e.printStackTrace();
			e.getClass();
		}
	}
}

